.nolist

;-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-;
; HEXDUMP - hexadecimal memory dumper by Chris Johan Smeele             ;
; Copyright (C) 2010 Chris JS                                           ;
; http://www.ticalc.org/cgi-bin/acct-view.cgi?userid=79918              ;
;-----------------------------------------------------------------------;
; This program is free software: you can redistribute it and/or modify  ;
; it under the terms of the GNU General Public License as published by  ;
; the Free Software Foundation, either version 3 of the License, or     ;
; (at your option) any later version.                                   ;
;                                                                       ;
; This program is distributed in the hope that it will be useful,       ;
; but WITHOUT ANY WARRANTY; without even the implied warranty of        ;
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         ;
; GNU General Public License for more details.                          ;
;                                                                       ;
; You should have received a copy of the GNU General Public License     ;
; along with this program.  If not, see <http://www.gnu.org/licenses/>. ;
;-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-;

#include "ti83plus.inc"
#define progstart $9d95
#define byte_divider $7c  ; '|'
.list
.org progstart - 2
    .db t2bytetok, tasmcmp
progentry:
	bcall(_runindicoff)
	ld ix,0  ; start address
	call hexscreenloop
	jp progend

hexscreenloop:
	;;
	; display 28 bytes as hex and their ascii chars
	push ix
	; don't clear the screen, these calls are too slow
	; bcall(_clrscrnfull)
	; bcall(_clrlcdfull)
	; bcall(_homeup)
	
	;;
	; display address range
	
	ld a,0
	ld (curcol),a
	ld a,7
	ld (currow),a
	ld ix,hexlinebuf
	ld (ix+2),0
	pop ix
	
	;;
	; start address
	
	ld a,'0'
	bcall(_putc)
	ld a,'x'
	bcall(_putc)
	
	push ix
	pop hl
	ld a,h
	push hl
	ld hl,hexlinebuf
	call makehex
	pop hl
	ld a,l
	ld hl,hexlinebuf
	push af
	bcall(_puts)
	pop af
	ld hl,hexlinebuf
	call makehex
	bcall(_puts)
	
	ld a,'-'
	bcall(_putc)
	
	;;
	; end address
	
	ld a,'0'
	bcall(_putc)
	ld a,'x'
	bcall(_putc)
	
	push ix
	pop hl
	ld de,27
	add hl,de
	ld a,h
	push hl
	ld hl,hexlinebuf
	call makehex
	pop hl
	ld a,l
	ld hl,hexlinebuf
	push af
	bcall(_puts)
	pop af
	ld hl,hexlinebuf
	call makehex
	bcall(_puts)
	
	ld a,' '
	bcall(_putc)
	ld a,$b2
	bcall(_putc)
	
	push ix
	ld ix,hexlinebuf
	ld (ix+2),byte_divider
	ld (ix+5),byte_divider
	ld (ix+8),byte_divider
	ld (ix+11),':'
	pop ix
	ld a,0
	ld (curcol),a
	ld (currow),a
	ld b,7
hexlineloop:
	;;
	; display one line of hex and ascii (4 bytes)
	push bc
	ld b,4
	ld hl,hexlinebuf
hexbyteloop:
	ld a,(ix)
	call makehex
	inc ix
	inc hl
	inc hl
	inc hl
	djnz hexbyteloop
	dec ix
	dec ix
	dec ix
	dec ix
	ld b,4
hexasciiloop:
	;;
	; put the ascii chars in the hexline buffer
	ld a,(ix)
	cp 0
	jr z,hexasciinochar
	cp $d6
	jr z,hexasciinochar
	ld (hl),a
	jr hexasciiok
hexasciinochar:
	;;
	; do not display null / 0xd6 chars
	ld (hl),' '
hexasciiok:
	inc ix
	inc hl
	djnz hexasciiloop
	call puthexline  ; print the line
	pop bc
	djnz hexlineloop
hexwaitkey:
	;;
	; wait for a keypress
	bcall(_getkey)
	cp $05
	jp z,hexscreenloop
	cp $04
	jp z,hexscreenloop
	cp $01
	jr z,hexrightkey
	cp $03
	jr z,hexupkey
	cp $02
	jr z,hexleftkey
	cp $8e
	jr z,hexzerokey
	cp $8f
	jr z,hexonekey
	cp $90
	jr z,hextwokey
	cp $91
	jr z,hexthreekey
	cp $92
	jr z,hexfourkey
	cp $93
	jr z,hexfivekey
	cp $94
	jr z,hexsixkey
	cp $95
	jr z,hexsevenkey
	cp $96
	jr z,hexeightkey
	cp $97
	jr z,hexninekey
	cp $09
	jr nz,hexwaitkey
	ret
hexleftkey:
	ld ix,0
	jp hexscreenloop
hexrightkey:
	push ix
	pop hl
	ld de,280  ; 10 screens
	add hl,de
	push hl
	pop ix
	jp hexscreenloop
hexupkey:
	ld de,28  ; 7*4 bytes per screen
	push ix
	pop hl
	ld a,l
	cp 29
	jr nc,hexupkeynocarry
	ld a,h
	cp 0
	jr z,hexwaitkey
hexupkeynocarry:
	or a
	sbc hl,de
	sbc hl,de
	push hl
	pop ix
	jp hexscreenloop
hexzerokey:
	ld ix,$0
	jp hexscreenloop
hexonekey:
	ld ix,$1014
	jp hexscreenloop
hextwokey:
	ld ix,$200c
	jp hexscreenloop
hexthreekey:
	ld ix,$3004
	jp hexscreenloop
hexfourkey:
	ld ix,$4018
	jp hexscreenloop
hexfivekey:
	ld ix,$5010
	jp hexscreenloop
hexsixkey:
	ld ix,$6008
	jp hexscreenloop
hexsevenkey:
	ld ix,$7000
	jp hexscreenloop
hexeightkey:
	ld ix,$8014
	jp hexscreenloop
hexninekey:
	ld ix,$900c
	jp hexscreenloop

makehex:
	;;
	; convert a byte to ascii-hex and put it in the buffer
	push bc
	push ix
	push hl
	push af
	push hl
	pop ix
	ld d,16
	ld l,a
	ld h,0
	call div_hl_d
	ld h,l
	ld l,a
	ld a,h
	cp 10
	jr c,hex1simple
	add a,'7'  ; 37h
	jr hex1end
hex1simple:
	add a,'0'
hex1end:
	ld (ix),a
	inc ix
	ld a,l
	cp 10
	jr c,hex2simple
	add a,'7'
	jr hex2end
hex2simple:
	add a,'0'
hex2end:
	ld (ix),a
	pop af
	pop hl
	pop ix
	pop bc
	ret

div_hl_d:
	;;
	; divide hl/d
	xor a
	ld b,16
divloop:
	add hl,hl
	rla
	jr c,divoverflow
	cp d
	jr c,divskip
divoverflow:
	sub d
	inc l
divskip:
	djnz divloop
	ret

puthexline:
	;;
	; display 4 hex values and their ascii chars
	ld hl, hexlinebuf
	bcall(_puts)
	ret

progend:
	;;
	; cleanup
	bcall(_runindicon)
	res doneprgm,(iy+doneflags)
	bcall(_clrscrnfull)
	bcall(_clrlcdfull)
	bcall(_homeup)
	ret

hexlinebuf:
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, 0

.end
end